﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using Wisej.Web;


namespace WisejWebApplication
{
    public partial class Window4 : Form
    {
        public Window4()
        {
            InitializeComponent();
        }

        private void panelContent_PanelCollapsed(object sender, EventArgs e)
        {

        }
        BindingSource bindingSource = new BindingSource();
        private void Window4_Load(object sender, EventArgs e)
        {
            listView1.DataSource = bindingSource;
            bindingSource.DataSourceChanged += BindingSource_DataSourceChanged;
            bindingSource.ListChanged += BindingSource_ListChanged;
            bindingSource.PositionChanged += BindingSource_PositionChanged;
            bindingSource.CurrentChanged += BindingSource_CurrentChanged;
            bindingSource.CurrentItemChanged += BindingSource_CurrentItemChanged;
            bindingSource.DataSource = new DataTest(Test.Data());
            // listView1.DataSource = Test.Data();


        }

        private void BindingSource_CurrentItemChanged(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("BindingSource_CurrentItemChanged");
        }

        private void BindingSource_CurrentChanged(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("BindingSource_CurrentChanged");
        }

        private void BindingSource_PositionChanged(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("BindingSource_PositionChanged");
        }

        private void BindingSource_ListChanged(object sender, System.ComponentModel.ListChangedEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("BindingSource_ListChanged");
        }

        private void BindingSource_DataSourceChanged(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("BindingSource_DataSourceChanged");
        }

      

        private void listView1_ItemBinding(object sender, ListViewItemBindingEventArgs e)
        {
            TextBox tbName = new TextBox();
            tbName.ReadOnly = true;
            tbName.DataBindings.Add("Text", e.DataRow, "Name", false, DataSourceUpdateMode.OnPropertyChanged);

            TextBox tbDesc = new TextBox();
            tbDesc.KeyDown += tbDesc_KeyDown;
            tbDesc.DataBindings.Add("Text", e.DataRow, "Desc", false, DataSourceUpdateMode.OnPropertyChanged);
            //e.ListViewItem.SubItems.Clear();
            e.ListViewItem.SubItems[0].Control = tbName;
            e.ListViewItem.SubItems[1].Control = tbDesc;

            //EXCEPTION
            //e.ListViewItem.SubItems.Add(new ListViewItem.ListViewSubItem { Control = tbName });
            //e.ListViewItem.SubItems.Add(new ListViewItem.ListViewSubItem { Control = tbDesc });

            //OK
            //e.ListViewItem.SubItems.AddRange(new ListViewItem.ListViewSubItem[] { new ListViewItem.ListViewSubItem { Control = tbName }, new ListViewItem.ListViewSubItem { Control = tbDesc } });
        }

        private void tbDesc_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Tab)  return;// (sender as TextBox).GetNextControl((sender as TextBox), true).Focus();
        }
    }

    public class Test
    {
        public string Name { get; set; }
        public string Desc { get; set; }
        public static List<Test> Data()
        {
            List<Test> list = new List<Test>();
            for (int i = 0; i < 50; i++)
            {
                list.Add(new Test { Name = "Name" + i, Desc = "Desc" + i });
            }
            return list;
        }
        public override int GetHashCode()
        {
            return Name.GetHashCode();
        }
        public override bool Equals(object obj)
        {
            if (obj is Test test) return this.Name == test.Name;
            return base.Equals(obj);
        }
    }
    public class DataTest : BindingList<Test>
    {
        public DataTest(List<Test> items)
        {
            foreach (var item in items)
                this.Add(item);
        }
    }
}
